<template>
  <div class="column" style="height: inherit">
    <port-manger-vue />
    <div class="col-shrink row text-center">
      Num motors: {{ num_motors }} <br />
      HW logs list: {{ hw_logs_list }} <br />
      FW version: {{ fw_version }} <br />
      CTRL list: {{ ctrl_list }} <br />
      REFS list: {{ refs_list }} <br />
      CTRL params: {{ ctrl_params }} <br />
      REFS params: {{ ref_params }} <br />
      CTRL logs: {{ ctrl_logs }} <br />
      Ready: {{ ready }}
    </div>
    <div class="row">
      <q-btn v-for="button in buttons" :key="'button' + button.name" :label="button.name" @click="button.onClick" />
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref } from 'vue';
import { useQuasar } from 'quasar';
import PortMangerVue from './PortManager.vue';
import { Serial } from './serial';

export default defineComponent({
  components: {
    PortMangerVue,
  },
  setup() {
    const $q = useQuasar();
    const fw_version = ref('');
    const num_motors = ref(0);
    const hw_logs_list = ref(['']);
    const ctrl_list = ref(['']);
    const refs_list = ref(['']);
    const ctrl_params = ref(['']);
    const ref_params = ref(['']);
    const ctrl_logs = ref(['']);
    const ready = ref(false);

    const notification = (message: string, caption?: string) => {
      $q.notify({
        message: message,
        caption: caption,
        color: 'secondary',
      });
    };

    const getFWVersion = () => {
      Serial.getVERsion((version: string) => {
        console.log(`Firmware VERsion: ${version}`);
        notification(`Firmware VERsion: ${version}`);
        fw_version.value = version;
      });
    };

    const getHWInfo = () => {
      Serial.getHWInfo((motorsNumber: number, loggables: Array<string>) => {
        console.log(`Motors available: ${motorsNumber}`);
        console.log(`HW loggables: ${loggables.toString()}`);
        notification(`Motors available: ${motorsNumber}`);
        notification(`HW loggables: ${loggables.toString()}`);
        num_motors.value = motorsNumber;
        hw_logs_list.value = loggables;
      });
      void window.ws_api.getHWInfo();
    };

    const getCtrlList = () => {
      Serial.getCTRLList((controllersList: Array<string>) => {
        console.log(`Controllers available: ${controllersList.toString()}`);
        notification(`Controllers available: ${controllersList.toString()}`);
        ctrl_list.value = controllersList;
      });
    };

    const getRefsList = () => {
      Serial.getREFList((referencesList: Array<string>) => {
        console.log(`References available: ${referencesList.toString()}`);
        notification(`References available: ${referencesList.toString()}`);
        refs_list.value = referencesList;
      });
    };

    const getCtrlParams = () => {
      Serial.getCTRLParameters('position_P', (ctrlName: string, parametersList: Array<string>) => {
        console.log(`${ctrlName} parameters: ${parametersList.toString()}`);
        notification(`${ctrlName} parameters: ${parametersList.toString()}`);
        ctrl_params.value = parametersList;
      });
    };

    const getRefsParams = () => {
      Serial.getREFParameters('constant', (refName: string, parametersList: Array<string>) => {
        console.log(`${refName} parameters: ${parametersList.toString()}`);
        notification(`${refName} parameters: ${parametersList.toString()}`);
        ref_params.value = parametersList;
      });
    };

    const getCtrlLogs = () => {
      Serial.getCTRLLoggables('position_PID', (ctrlName: string, loggablesList: Array<string>) => {
        console.log(`${ctrlName} loggables: ${loggablesList.toString()}`);
        notification(`${ctrlName} loggables: ${loggablesList.toString()}`);
        ctrl_logs.value = loggablesList;
      });
    };

    const getReady = () => {
      Serial.getReady((readyFlag: boolean) => {
        console.log(`Ready: ${String(readyFlag)}`);
        notification(`Ready: ${String(readyFlag)}`);
        ready.value = readyFlag;
      });
    };

    const setController = () => {
      Serial.setCTRL('position_P', 0, [1]);
      // Serial.setCTRL('position_PID', 0, [1, 0, 0]);
    };

    const setHWLoggables = () => {
      Serial.setHWLoggables(['first','second']);
    };

    const setCTRLLoggables = () => {
      Serial.setCTRLLoggables(0,['first','second']);
    };

    const setReference = () => {
      Serial.setREF('constant', 0, [4.0]);
    };

    const startLoop = () => {
      Serial.startLoop(1000, 30);
    };

    const standby = () => {
      Serial.standby();
    };

    const buttons = [
      {
        name: 'HW Info',
        onClick: getHWInfo,
      },
      {
        name: 'Firmware',
        onClick: getFWVersion,
      },
      {
        name: 'CTRL List',
        onClick: getCtrlList,
      },
      {
        name: 'REFS List',
        onClick: getRefsList,
      },
      {
        name: 'CTRL Params',
        onClick: getCtrlParams,
      },
      {
        name: 'REF Params',
        onClick: getRefsParams,
      },
      {
        name: 'CTRL Logs',
        onClick: getCtrlLogs,
      },
      {
        name: 'Ready',
        onClick: getReady,
      },
      {
        name: 'SET CTRL',
        onClick: setController,
      },
      {
        name: 'SET HW LOGS',
        onClick: setHWLoggables,
      },
      {
        name: 'SET CTRL LOGS',
        onClick: setCTRLLoggables,
      },
      {
        name: 'Set REF',
        onClick: setReference,
      },
      {
        name: 'Start Loop',
        onClick: startLoop,
      },
      {
        name: 'Standby',
        onClick: standby,
      },
    ];

    return {
      buttons,
      ready,
      fw_version,
      num_motors,
      hw_logs_list,
      ctrl_list,
      refs_list,
      ctrl_params,
      ref_params,
      ctrl_logs,

      getHWInfo,
      getFWVersion,
      getCtrlList,
      getRefsList,
      getCtrlParams,
      getRefsParams,
      getCtrlLogs,
      getReady,

      setController,
      setHWLoggables,
      setCTRLLoggables,
      setReference,
      startLoop,
      standby,
    };
  },
});
</script>
